function memoryTest(subjectName)
%inputs (subjectName)
%randomized conditions
%1 = black numbers
% 2 - colored numbers
% 3 - miscolored numbers
% 4 - low contrast numbers
%i.e. ('lap')

thisfcn = 'memoryTest';
rootdir = setrootdir(thisfcn);

if nargin < 1,
    parameters = inputdlg('Subject initials:','Texsyn Toolbox',1);
    pause(0.5);
    subjectName = parameters{1};
end

%load 4 random matrices
myMatrices = [rootdir 'memoryMatrices.mat']
load(myMatrices)

%load synesthete's colors
myfilename = [rootdir 'Data\graphemeColorResults_' subjectName '.mat']
load(myfilename)

row =2;  %this will pick off the 2nd row of colors
data=sortrows(data);
for i=1:3:30
    t=(i+2)/3;
    if sum(data(i+row-1,2:4))==-3
        data(i+row-1,2:4)=0;
    end
    colormat(t,1:3)=data(i+row-1,2:4);
end

colormat(A(2,2)+1, :);
colormat(:,4) = shuffle(0:9)';  %4th column for case 3 below (to match certain digits with colors)


figure(1);
set(gcf,'Position',[0 50 1400 900]);
clf
axis off;
keyIsDown = 0;

condition = shuffle([1:4]);

for i = 1:4
    for y = 1:7
        for x=1:7
            if condition(i) == 1        
                text(y*0.1, 1 - x*0.1,  num2str(A(x,y)), 'Fontsize', 40);
            elseif condition(i) == 2
                text(y*0.1, 1 - x*0.1,  num2str(Bx(x,y)), 'Fontsize', 40, 'Color', colormat(Bx(x,y)+1,1:3));
            elseif condition(i) == 3
                mycurrentNumber = C(x,y);  %will return value from 0 to 9;
                mycolorRow = find(colormat(:,4) == mycurrentNumber);
                text(y*0.1, 1 - x*0.1,  num2str(C(x,y)), 'Fontsize', 40, 'Color', colormat(mycolorRow,1:3));
            elseif condition(i) == 4
                text(y*0.1, 1 - x*0.1,  num2str(D(x,y)), 'Fontsize', 40, 'Color', [0.7 0.7 0.7]);
            end
        end
    end
    pause(60);
    nameFile=['Z:\share\Synesthesia\ColorGraphemeData\jpegs\matrixGraph_',subjectName,num2str(condition(i)),'.jpg']
    print(gcf, '-djpeg', nameFile)
    clf;
    axis off;
    text(0.05, 0.5, 'Please write down the matrix you just saw.', 'Fontsize', 25);
    text(0.05, 0.4, 'When finished, press any key to proceed.', 'Fontsize', 25);
    pause;
    clf;
    axis off;
end

text(0.05, 0.5, 'Thank you for your participation.  Hit any key to exit.', 'Fontsize', 25);
axis off;
pause;
close all;