function MonthColor(subjectName)
%MonthColor: allows subjects to match colors to synesthetic percepts of
%months.
%
%This program is part of the TexSyn Toolbox developed by David Eagleman,PhD
%eagleman@synesthete.org
%Full package freely downloadable from www.synesthete.org

thisfcn = 'MonthColor';
rootdir = setrootdir(thisfcn);

if nargin < 1,
    parameters = inputdlg('Subject initials:','TexSyn Toolbox',1);
    pause(0.5);
    subjectName = parameters{1};
end
myfilename = getSafeFilename(thisfcn,subjectName); %this will be used to save results

numTrials = 36;

data=zeros (numTrials,4);
vec = [1:12 1:12 1:12];
vec=shuffle(vec);
data(:,1)=vec';
months=char('January', 'February' , 'March' , 'April' , 'May',  'June' , 'July', 'August', 'September', 'October', 'November', 'December');

figure(1);
set(gcf, 'Position', [100 50 1150 350]);
set(gcf,'Name','Synesthesia Testing');

for i=1:numTrials
    figure(1);
    text(.5,.5,months(vec(i),:), 'Fontsize', 50);
    axis off;
    [r, g, b] = Palettemaker;
    data(i,2:4)=[r,g,b];
    figure(1);
    clf;
    text(.5,.5,'XXXXXXX','Fontsize', 50);
    axis off;
    pause(0.1);
    clf;
    data
end
close(2);
text(.01,.3,'Thank you for your participation','Fontsize', 50);
text(.3,.1,'Hit any key to exit', 'Fontsize', 15);
axis off;

save(myfilename, 'data', 'months')

MonthDisplay(subjectName);
pause;
close(gcf);