function SoundDisplay(subjectName)
%SoundDisplay: displays the matched colors to synesthetic percepts of
%sounds.
%
%This program is part of the TexSyn Toolbox developed by David Eagleman,PhD
%eagleman@synesthete.org
%Full package freely downloadable from www.synesthete.org

%load the data
if nargin < 1,
    parameters = inputdlg('Subject initials:','SoundDisplay',1);
    pause(0.5);
    subjectName = parameters{1};
end

%load the subject's colors
rootdir = setrootdir('SoundDisplay');
myfilename = [rootdir 'Data\SoundColorResults_' subjectName '.mat']
load(myfilename)

%sort the data matrix
newdata=sortrows(data);
newdata
numPieces=29;
counter=0;
for i=1:3:numPieces*3
    t=(i+2)/3;
    if newdata(i, 2) > -1 & newdata(i+1, 2) > -1 & newdata(i+2, 2) > -1 %as long as they didn't choose "no color"
        r=abs(newdata(i,2)-newdata(i+1,2)) + abs(newdata(i+2,2)-newdata(i+1,2)) + abs(newdata(i+2,2)-newdata(i,2));
        g=abs(newdata(i,3)-newdata(i+1,3)) + abs(newdata(i+2,3)-newdata(i+1,3)) + abs(newdata(i+2,3)-newdata(i,3));
        b=abs(newdata(i,4)-newdata(i+1,4)) + abs(newdata(i+2,4)-newdata(i+1,4)) + abs(newdata(i+2,4)-newdata(i,4));
        counter=counter+1;
        sum1=r+g+b;
        diffMatrix(t,1)=sum1;
    else
        diffMatrix(t,1)=0;
    end
end
%diffMatrix

counter

clips=char('TwenCentFox','Boxer','Seductive','Airport','Hitchcock','Applause','Bee','Bird','Bleep','Bluejay','Boing','Classictwo','Bottle','Bubble','Coke','TOverture','Buzzer','Cello', 'Guitar','Haydn','Horse','Entertainer',   'Giggling', 'Ouch',  'Plop','DrumsN','Engine','Elephant','Chirps')

newsum=sum(diffMatrix);
diffScore=newsum/counter;

figure;
set(gcf, 'Position', [50 50 800 850]);
set(gcf,'Name','Sound-Color Synesthesia Results');
mytitle = sprintf('%s Difference score = %.2f', subjectName, diffScore);
title(mytitle, 'Fontsize', 20);	
axis off;

for trial = 1:3
    for i=1:3:numPieces*3
        text((trial-1)*.26, .95+i*-0.01, clips(newdata(i),:),'Fontsize', 15, 'Color', newdata([i+trial-1],2:4));
        text(.9, .95+i*-.01, num2str(diffMatrix((i+2)/3,1)), 'Fontsize', 15)
        text(.79, .98, 'Difference Score', 'Fontsize', 15)
        text(.80, .95-37*.028, 'Total=', 'Fontsize', 15)
        text(.95, .95-37*.028, num2str(newsum), 'Fontsize', 15)
    end
end 
