function [r, g, b] = Palettemaker
colors=hsv;
mycolor = zeros(70,64,3);
r=rand;
x=ceil(r*64);

mycolor(1,1:(64-x),1)=colors((x+1):64,1)';  %makes palette start in a random hue
mycolor(1,(64-x+1):64,1)=colors(1:x,1)';
mycolor(1,1:(64-x),2)=colors((x+1):64,2)';
mycolor(1,(64-x+1):64,2)=colors(1:x,2)';
mycolor(1,1:(64-x),3)=colors((x+1):64,3)';
mycolor(1,(64-x+1):64,3)=colors(1:x,3)';

for slice=1:3
    for i = 2:64
        mycolor(i,:,slice) = mycolor(1,:,slice);
    end
end

graymat = ones(64,64) * 0.5;
whiteMat = ones(67,64);
blackMat = zeros(67,64);

for slice=1:3
    for i=1:64
        coeff = i/64;
        paletteMat(i,:, slice) = (1-coeff)*mycolor(i,:,slice) + coeff*graymat(i,:);
    end
    paletteMat(65:67,:,slice) = .5;
    paletteMat(68:70,:,slice) = 0;
end

figure(2);
set(gcf, 'Position', [100 400 1150 500]);
set(gcf,'Name','Color Palette');
set(gcf,'MenuBar','none', 'NumberTitle', 'off', 'SelectionHighlight', 'off', 'Resize','off');
subplot(1,2,1);
image(paletteMat);
axis off;
text(28,69, 'No Color', 'Fontsize', 10, 'Color', 'white');
luminance = .5 +floor(rand*7-3)*0.05;
lastx = 1;
lasty = 1;
updateFlag = 0;
lumPaletteMat = paletteMat;
while 1
    
    [x y button] = ginput(1);
    if button==27 break; end;
    
    if button==28  %left arrow  --> decrease luminance
        luminance = luminance - 0.05;
        if luminance < 0.0
            luminance = 0.0;
        end
        updateFlag = 1;
        %luminance
    end
    
    if button==29 %right arrow
        luminance = luminance + 0.05;
        if luminance > 1.0;
            luminance = 1.0;
        end
        updateFlag = 1;
        %luminance
    end
    
    if updateFlag
        if luminance < 0.5
            for slice=1:3
                lumPaletteMat(1:67,:, slice) = (2*luminance)*paletteMat(1:67,:,slice) + (1-2*luminance)*blackMat;
            end
        end
        
        if luminance > 0.5
            for slice=1:3
                lumPaletteMat(1:67,:, slice) = (2 - 2*luminance)*paletteMat(1:67,:,slice) + (2*luminance - 1)*whiteMat;
            end
        end
        
        if luminance == 0.5
            lumPaletteMat = paletteMat;
        end
        
        subplot(1,2,1);
        image(lumPaletteMat);
        axis off;
        x = lastx; 
        y = lasty;  %this is nec b/c ginput returns funny x,y when a button is pressed
        
        updateFlag = 0;  %reset
    end
    
    %catch loop for clicking outside the color palette
    if x>64 x=lastx; y=lasty; end
    if y>70 x=lastx; y=lasty; end
    if x<1 x=lastx; y=lasty; end
    if y<1 x=lastx; y=lasty; end
    
    paletteMat(ceil(y), ceil(x), :);
    for slice=1:3
        swatchMat(1,1,slice) = lumPaletteMat(ceil(y), ceil(x), slice);
    end
    subplot(1,2,2);
    %ceil(y)
    %clf;
    if 67<ceil(y) && ceil(y)<=70
        colormap([1, 1, 1]);
        image(colormap);
        text(1.5,1,'No Color', 'Fontsize', 15);
    else
        image(swatchMat);
    end
    axis off;
    
    if (button==32 || button==13) %this is the SPACE BAR key or ENTER key to register their answer
        disp('Space Bar or Enter pressed');
        clf;
        for slice=1:3
            swatchMat(1,1,slice) = lumPaletteMat(ceil(y), ceil(x), slice);
        end
        if ceil(y)>67 
            r=-1;
            g=-1;
            b=-1;
        else
            r = swatchMat(1,1,1);
            g = swatchMat(1,1,2);
            b = swatchMat(1,1,3);
        end
        axis off;
        break;    
    end

lastx = ceil(x);  %store it for next loop
lasty = ceil(y);

end

%disp('program exiting');