function WeekdayColor(subjectName)
%WeekdayColor: allows subjects to match colors to synesthetic percepts of
%weekdays.
%
%This program is part of the TexSyn Toolbox developed by David Eagleman,PhD
%eagleman@synesthete.org
%Full package freely downloadable from www.synesthete.org

thisfcn = 'WeekdayColor';
rootdir = setrootdir(thisfcn);

if nargin < 1,
    parameters = inputdlg('Subject initials:','TexSyn Toolbox',1);
    pause(0.5);
    subjectName = parameters{1};
end
myfilename = getSafeFilename(thisfcn,subjectName); %this will be used to save results

numTrials = 28;

data=zeros (numTrials,4);

vec = [1:7 1:7 1:7 1:7];
vec=shuffle(vec);
data(:,1)=vec';
weekday=char('Monday', 'Tuesday' , 'Wednesday' , 'Thursday' , 'Friday',  'Saturday' , 'Sunday');
figure;

set(gcf, 'Position', [0 100 1200 800]);
set(gcf,'Name','TexSyn Toolbox');

for i=1:numTrials
    figure(1);
    set(gcf, 'Position', [100 50 1150 350]);
    set(gcf,'Name','Synesthesia Testing');
    text(.5,.5,weekday(vec(i),:),'Fontsize', 50);
    axis off;
    [r, g, b] = Palettemaker;
    data(i,2:4)=[r,g,b];
    figure(1);
    clf;
    text(.5,.5,'XXXXXXX','Fontsize', 50);
    axis off;
    pause(0.1);
    clf;
    data
end
close(2);
text(.05,.5,'Thank you for your participation','Fontsize', 50);
text(.3,.3,'Hit any key to exit', 'Fontsize', 15);
axis off;


myfilename = getSafeFilename(thisfcn,subjectName); %this will be used to save results
save(myfilename, 'data', 'weekday');

WeekdayDisplay(subjectName);
pause;
close(gcf);