function WeekdayDisplay(subjectName)
%WeekdayDisplay: displays the matched colors to synesthetic percepts of weekdays.
%
%This program is part of the TexSyn Toolbox developed by David Eagleman,PhD
%eagleman@synesthete.org
%Full package freely downloadable from www.synesthete.org

if nargin < 1,
    parameters = inputdlg('Subject initials:','TexSyn Toolbox',1);
    pause(0.5);
    subjectName = parameters{1};
end

%load the subject's colors
rootdir = setrootdir('WeekdayDisplay');
myfilename = [rootdir 'Data\WeekdayColorResults_' subjectName '.mat']
load(myfilename);

weekday=char('Monday', 'Tuesday' , 'Wednesday' , 'Thursday' , 'Friday',  'Saturday' , 'Sunday');

%sort the data matrix
newdata=sortrows(data);

counter=0;
for i=1:4:28
    t=(i+3)/4;
%     r=abs(newdata(row,2)-newdata(row+1,2)) + abs(newdata(row+1,2)-newdata(row+2,2)) + abs(newdata(row+2,2)-newdata(row,2));
%     g=abs(newdata(row,3)-newdata(row+1,3)) + abs(newdata(row+1,3)-newdata(row+2,3)) + abs(newdata(row+2,3)-newdata(row,3));
%     b=abs(newdata(row,4)-newdata(row+1,4)) + abs(newdata(row+1,4)-newdata(row+2,4)) + abs(newdata(row+2,4)-newdata(row,4));
%     diffMatrix(t,1)=r+g+b;
%     
%     if newdata(row,2) > -1
%         counter=counter+1;
%     end
% end
% 
% counter=0;
% for i=1:3:length(data)
%     t=(i+2)/3;
    if newdata(i, 2) > -1 & newdata(i+1, 2) > -1 & newdata(i+2, 2) > -1 %as long as they didn't choose "no color"    
        r=abs(newdata(i,2)-newdata(i+1,2)) + abs(newdata(i+2,2)-newdata(i+1,2)) + abs(newdata(i+2,2)-newdata(i,2));
        g=abs(newdata(i,3)-newdata(i+1,3)) + abs(newdata(i+2,3)-newdata(i+1,3)) + abs(newdata(i+2,3)-newdata(i,3));
        b=abs(newdata(i,4)-newdata(i+1,4)) + abs(newdata(i+2,4)-newdata(i+1,4)) + abs(newdata(i+2,4)-newdata(i,4));
        diffMatrix(t,1)=r+g+b;
        counter=counter+1; %counter will represent the row with the most colored graphemes
    else
        diffMatrix(t,1)=NaN;  %if they chose 'No Color', it is not counted in the color variability score
    end
end

%diffScore = sum(diffMatrix)/counter;
diffScore=sum(diffMatrix(~isnan(diffMatrix)))/counter  %this sum excludes anything that is not a number

figure;
set(gcf, 'Position', [50 100 1000 500]);
set(gcf,'Name','WeekdayColor Synesthesia Results');
mytitle = sprintf('%s Color Variability score = %.2f', subjectName, diffScore);
title(mytitle, 'Fontsize', 20);	
axis off;

for trial = 1:4
    for i=1:4:28
        text((trial-1)*.19, .95+i*-0.028, weekday(newdata(i),:),'Fontsize', 18, 'Color', newdata([i+trial-1],2:4));
        text(.9, .95+i*-.028, num2str(diffMatrix((i+3)/4,1)), 'Fontsize', 18);
        text(.79, .99, 'Color Variability Score', 'Fontsize', 20);
    end
end 
